#!/bin/bash
if [ -z $TESTRTDIR ]
then
echo please set TESTRTDIR first!
exit 1
fi


JAVA=`java -version > /dev/null 2>&1`
if [ $? != 0 ] 
then
	echo "Java not found"
	echo "Please set JAVA_HOME and PATH variables to a newer java kit"
	exit 1
fi

VER=`java -version 2>&1 | head -n1|awk '{print $NF}'`

if [ `echo $VER | grep "1.4"` ]
then
	echo "Bad java release ! Minimum is java 1.5"
	echo "Please set JAVA_HOME and PATH variables to a newer java kit"
	exit 1
fi

rm -f TestRTAdapter.log
ls   $TESTRTDIR/RQMAdapter/TestRTadapter/lib/*.jar | grep -v "com.ibm.rqm.adapter.library_1.0.0"> jars.txt
CLPATH=""
for line in $(cat jars.txt) 
do
CLPATH=$line:$CLPATH
done

$TESTRTDIR/testrtinit.sh

java -Dlog4j.configuration=file:$TESTRTDIR/RQMAdapter/TestRTadapter/log4j.properties -classpath "$CLPATH" com.ibm.rqm.adapter.testrt.QMTestRTAdapter $*
