#!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Source Instrumentation launcher -*-                #
#                                                                              #
#                                                                              #
################################################################################

#$Id: attolcclibh.pl,v 1.1.2.2 2009/07/20 13:06:10 rfrance Exp $

require $SCRIPTDIR . "Fcts.pl";
ReadProductName();
$launcher=launcherName();

################################################################################
sub debug #($)
{
my $s=shift;
print STDERR "#>$s\n";
}
################################################################################
sub printEnvironment
{
  debug("#Perl Script Command Line (" . scalar(@ARGV) . " args):\n# $launcher [" . join ("] [", @ARGV) . "]\n");
  print STDERR "#     ATLTGT     = " . $ENV{'ATLTGT'} . "\n";
  print STDERR "#     TESTRTDIR  = " . $ENV{'TESTRTDIR'} . "\n";
}
###########################################################################
# print help file
sub help
{
    print STDERR "#?$SMALL_PRODUCT_NAME-I-".uc($launcher).", Usage:  $launcher <launcher options> <instrum options> --<settings> -- <compilation command>\n";
    open HP, "<$ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt);
    while (<HP>) {print;} close(HP);
}
###########################################################################
# print usage
sub usage
{
    print STDERR "#?$SMALL_PRODUCT_NAME-I-".uc($launcher).", Usage:  $launcher <launcher options> <instrum options> --<settings> -- <compilation command>\n";
    print " launcher options:\n";
    print " -help show this usage\n";
    print " -opt=<optionsFile> all options can be listed in the file instead of the command line (except -tmpdir)s\n";
    print " -nostop keep intermediate files, write a logfile, launch standard compilation and continue if instrumentation fails\n";
    print " -keep keep intermediate files\n";
    print " -# (silent) shows but does not execute the commands\n";
    print " -verbose display more about executed commands\n";
    print " -force_tdp_cc force the compilation of the TP at the first instrumentation\n";
    print " -force_c   force the instrumention as C code\n";
    print " -force_cpp force the instrumention as C++ code\n";
    print " -nolink does not interpret as a link (used when it cannot be detected on the compilation command)\n";
    print " -noTDP do not generate the TP. So env_${launcher}.pl file is no more used and so not generated\n";
    print " -noList do not generate the list of generated files ${launcher}files.log\n";
    print " -log[=<logFileName>] create a log recording all stderr and stdout\n";
    print " -ignore=<file>[,<file>....] launch standard compilation for listed files. if a file has .lst extension,\n";
    print "     all listed files in the .lst file will be ignored. The .lst file may contains one or more file list .lst as well\n";
    print " 	the file lists in the .lst file may be listed on one line using ',' as separator and/or on multiple lines\n";
    print " -instrum=<file>[,<file>....] launch standard compilation for non listed files. (same format as for ignore option)\n";
    print " -tmpdir=myPath store intermediate files in myPath instead of source directory (this option cannot be part of the optionFile)\n";
    print " -ENV_XXXX=YYYY set the environment variable XXXX to the value YYYY where XXXX and YYYY may be any name and value used by the instrumentation steps (this option cannot be part of the optionFile)\n";
    print " -treatmt=<file.pl> load intermediate treatment described in Perl to execute before, and after each instrumentation step\n";
    print "                    (this option cannot be part of the optionFile)\n";
    print " -otc=<file>[,<file>....] allows to specify the contract checking available for this application (postprocessing should be done manually)\n";
    print " -codeReview[=<file>] enable the code checking using the configuration file <file>\n";
    print " -metric[=<path>] enable the metric computation. Result files are written in <path>\n";
    #keep this line as last one (kit qualif)
    print " --help print the enhanced documentation. (More available options)\n\n";
}
################################################################################
sub launcherName
{
my ($dirlauncher,$launcherBase,$extl)=SplitFileName($0);
return $launcherBase;
}
1;


