

sub rsfGetInput
{
    my ($inputVar,$default) = @_;
    my $inputValue = $default; 
    if (defined $ENV{RSI_PLAY_BACK}) {
        # In playback mode.
        my $found = 0;
        if (open(PLAY,"<$ENV{RSI_PLAY_BACK}")) {
            while (<PLAY>) {
                if (m/^\d+ $inputVar (.*)/) {
                    $inputValue = $1;
                    $found = 1;
                    last;
                }
            }
            close PLAY;
        }
        return $inputValue if $found; # and no need to record this.
    }
    # Input not recorded OR not in playback mode.
    # Prompt user for input.
    $inputValue = <STDIN>;
    chomp $inputValue;
    # Use default value if no input.
    $inputValue = $default if ($inputValue eq '');
    # Record the input if in record mode.
    if (defined $ENV{RSI_RECORD_IN}) {
        if (open(REC,">>$ENV{RSI_RECORD_IN}")) {
            print REC "1 $inputVar $inputValue\n";
            close REC;
        }
    }
    return $inputValue;
}

1;
